---
title: "Update an activity completion rule"
description: "Replaces the activity completion configuration, validates it against the module, and schedules affected learners for reevaluation.\n\n### Quire permissions\n\nRequired capability: `activity/update`.\n\nCredential scopes: `completions:write`.\n\nThe acting subject must also be allowed to perform this action in the organisation."
image: "https://docs.quirelms.com/og.png"
---

> Documentation Index
> Fetch the complete documentation index at: https://docs.quirelms.com/llms.txt
> Use this file to discover all available pages before exploring further.

Path: Quire API › completions

`PATCH /completion_rules/{activity_id}`

Replaces the activity completion configuration, validates it against the module, and schedules affected learners for reevaluation.

\### Quire permissions

Required capability: `activity/update`.

Credential scopes: `completions:write`.

The acting subject must also be allowed to perform this action in the organisation.

## Authentication

Requires one of the following:

- `apiKey`, http, header `Authorization`, scopes: `completions:write`
- `oauth2`, oauth2, scopes: `completions:write`

## Path parameters

- `updateCompletionRule.path.activity_id` (string, required)

## Header parameters

- `updateCompletionRule.header.Quire-Version` (string, optional) — The dated API revision to serve this request at. Omitted, the request is served at the revision the credential was issued against. The response echoes the revision actually applied.
  - format `date`
- `updateCompletionRule.header.Idempotency-Key` (string, optional) — A caller-chosen key making this request safe to retry. A replay of a completed request returns the recorded response with `Idempotency-Replayed: true`. Reusing a key for a different request is refused.
  - maxLength 255

## Request body

_Required._

- `updateCompletionRule.completion` (object, required)
  - `updateCompletionRule.completion.mode` (string, required)
    - one of `"none"`, `"manual"`, `"automatic"`
  - `updateCompletionRule.completion.onView` (boolean, optional)
  - `updateCompletionRule.completion.onGrade` (boolean, optional)
  - `updateCompletionRule.completion.onPass` (boolean, optional)
  - `updateCompletionRule.completion.rules` (map<boolean>, optional)
  - `updateCompletionRule.completion.expectedBy` (string, optional)
    - format `date`; pattern `^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))$`

## Example request

```json
{
  "completion": {
    "mode": "none",
    "onView": true,
    "onGrade": true,
    "onPass": true,
    "rules": {
      "property1": true,
      "property2": true
    },
    "expectedBy": "2019-08-24"
  }
}
```

## Code samples

### cURL

```curl
curl --request PATCH \
  --url https://your-organisation.quirelms.com/api/v1/completion_rules/string \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "completion": {
    "mode": "none",
    "onView": true,
    "onGrade": true,
    "onPass": true,
    "rules": {
      "property1": true,
      "property2": true
    },
    "expectedBy": "2019-08-24"
  }
}
'
```

### TypeScript

```typescript
const url = 'https://your-organisation.quirelms.com/api/v1/completion_rules/string';
const options = {
  method: 'PATCH',
  headers: {'Content-Type': 'application/json', Authorization: 'Bearer <token>'},
  body: JSON.stringify({
    completion: {
      mode: 'none',
      onView: true,
      onGrade: true,
      onPass: true,
      rules: {property1: true, property2: true},
      expectedBy: '2019-08-24'
    }
  })
};

fetch(url, options)
  .then(res => res.json())
  .then(json => console.log(json))
  .catch(err => console.error(err));
```

### Python

```python
import requests

url = "https://your-organisation.quirelms.com/api/v1/completion_rules/string"

payload = { "completion": {
        "mode": "none",
        "onView": True,
        "onGrade": True,
        "onPass": True,
        "rules": {
            "property1": True,
            "property2": True
        },
        "expectedBy": "2019-08-24"
    } }
headers = {
    "Content-Type": "application/json",
    "Authorization": "Bearer <token>"
}

response = requests.patch(url, json=payload, headers=headers)

print(response.text)
```

## Responses

### 200

Success.

#### Example

```json
{
  "activity_id": "98dae057-958f-4b2f-9ed4-41f109afdc3f",
  "completion": {
    "mode": "none",
    "onView": true,
    "onGrade": true,
    "onPass": true,
    "rules": {
      "property1": true,
      "property2": true
    },
    "expectedBy": "2019-08-24"
  },
  "learners_to_reevaluate": 9007199254740991
}
```

- `updateCompletionRule.response.200.activity_id` (string, required)
  - format `uuid`; pattern `^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$`
- `updateCompletionRule.response.200.completion` (object, required)
  - `updateCompletionRule.response.200.completion.mode` (string, required)
    - one of `"none"`, `"manual"`, `"automatic"`
  - `updateCompletionRule.response.200.completion.onView` (boolean, optional)
  - `updateCompletionRule.response.200.completion.onGrade` (boolean, optional)
  - `updateCompletionRule.response.200.completion.onPass` (boolean, optional)
  - `updateCompletionRule.response.200.completion.rules` (map<boolean>, optional)
  - `updateCompletionRule.response.200.completion.expectedBy` (string, optional)
    - format `date`; pattern `^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))$`
- `updateCompletionRule.response.200.learners_to_reevaluate` (integer, required)
  - min 0; max 9007199254740991

### 401

The credential is missing, malformed, expired or revoked.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `updateCompletionRule.response.401.type` (string, required)
  - format `uri`
- `updateCompletionRule.response.401.title` (string, required)
- `updateCompletionRule.response.401.status` (integer, required)
- `updateCompletionRule.response.401.code` (string, required)
- `updateCompletionRule.response.401.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `updateCompletionRule.response.401.detail` (string, required)
- `updateCompletionRule.response.401.request_id` (string, required)
- `updateCompletionRule.response.401.docs_url` (string, required)
  - format `uri`
- `updateCompletionRule.response.401.errors` (array<object>, optional)
  - `updateCompletionRule.response.401.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `updateCompletionRule.response.401.errors.code` (string, required)
  - `updateCompletionRule.response.401.errors.detail` (string, required)
- `updateCompletionRule.response.401.retry_after` (integer | null, optional)

### 403

The credential lacks the scope this operation requires, or the acting subject lacks the capability.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `updateCompletionRule.response.403.type` (string, required)
  - format `uri`
- `updateCompletionRule.response.403.title` (string, required)
- `updateCompletionRule.response.403.status` (integer, required)
- `updateCompletionRule.response.403.code` (string, required)
- `updateCompletionRule.response.403.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `updateCompletionRule.response.403.detail` (string, required)
- `updateCompletionRule.response.403.request_id` (string, required)
- `updateCompletionRule.response.403.docs_url` (string, required)
  - format `uri`
- `updateCompletionRule.response.403.errors` (array<object>, optional)
  - `updateCompletionRule.response.403.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `updateCompletionRule.response.403.errors.code` (string, required)
  - `updateCompletionRule.response.403.errors.detail` (string, required)
- `updateCompletionRule.response.403.retry_after` (integer | null, optional)

### 404

No such resource, or none this credential is permitted to know about.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `updateCompletionRule.response.404.type` (string, required)
  - format `uri`
- `updateCompletionRule.response.404.title` (string, required)
- `updateCompletionRule.response.404.status` (integer, required)
- `updateCompletionRule.response.404.code` (string, required)
- `updateCompletionRule.response.404.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `updateCompletionRule.response.404.detail` (string, required)
- `updateCompletionRule.response.404.request_id` (string, required)
- `updateCompletionRule.response.404.docs_url` (string, required)
  - format `uri`
- `updateCompletionRule.response.404.errors` (array<object>, optional)
  - `updateCompletionRule.response.404.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `updateCompletionRule.response.404.errors.code` (string, required)
  - `updateCompletionRule.response.404.errors.detail` (string, required)
- `updateCompletionRule.response.404.retry_after` (integer | null, optional)

### 409

The request conflicts with the current state, with a previous use of the same idempotency key, or with a concurrent write.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `updateCompletionRule.response.409.type` (string, required)
  - format `uri`
- `updateCompletionRule.response.409.title` (string, required)
- `updateCompletionRule.response.409.status` (integer, required)
- `updateCompletionRule.response.409.code` (string, required)
- `updateCompletionRule.response.409.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `updateCompletionRule.response.409.detail` (string, required)
- `updateCompletionRule.response.409.request_id` (string, required)
- `updateCompletionRule.response.409.docs_url` (string, required)
  - format `uri`
- `updateCompletionRule.response.409.errors` (array<object>, optional)
  - `updateCompletionRule.response.409.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `updateCompletionRule.response.409.errors.code` (string, required)
  - `updateCompletionRule.response.409.errors.detail` (string, required)
- `updateCompletionRule.response.409.retry_after` (integer | null, optional)

### 422

The request was understood and its content is not valid. `errors` names each field.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `updateCompletionRule.response.422.type` (string, required)
  - format `uri`
- `updateCompletionRule.response.422.title` (string, required)
- `updateCompletionRule.response.422.status` (integer, required)
- `updateCompletionRule.response.422.code` (string, required)
- `updateCompletionRule.response.422.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `updateCompletionRule.response.422.detail` (string, required)
- `updateCompletionRule.response.422.request_id` (string, required)
- `updateCompletionRule.response.422.docs_url` (string, required)
  - format `uri`
- `updateCompletionRule.response.422.errors` (array<object>, optional)
  - `updateCompletionRule.response.422.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `updateCompletionRule.response.422.errors.code` (string, required)
  - `updateCompletionRule.response.422.errors.detail` (string, required)
- `updateCompletionRule.response.422.retry_after` (integer | null, optional)

### 429

A rate limit or a concurrency cap was reached. `Retry-After` says when to try again.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `updateCompletionRule.response.429.type` (string, required)
  - format `uri`
- `updateCompletionRule.response.429.title` (string, required)
- `updateCompletionRule.response.429.status` (integer, required)
- `updateCompletionRule.response.429.code` (string, required)
- `updateCompletionRule.response.429.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `updateCompletionRule.response.429.detail` (string, required)
- `updateCompletionRule.response.429.request_id` (string, required)
- `updateCompletionRule.response.429.docs_url` (string, required)
  - format `uri`
- `updateCompletionRule.response.429.errors` (array<object>, optional)
  - `updateCompletionRule.response.429.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `updateCompletionRule.response.429.errors.code` (string, required)
  - `updateCompletionRule.response.429.errors.detail` (string, required)
- `updateCompletionRule.response.429.retry_after` (integer | null, optional)

### 500

Something failed at our end. Quote `request_id` when reporting it.

#### Example

```json
{
  "type": "http://example.com",
  "title": "string",
  "status": 0,
  "code": "string",
  "category": "validation",
  "detail": "string",
  "request_id": "string",
  "errors": [
    {
      "path": "string",
      "code": "string",
      "detail": "string"
    }
  ],
  "retry_after": 0,
  "docs_url": "http://example.com"
}
```

- `updateCompletionRule.response.500.type` (string, required)
  - format `uri`
- `updateCompletionRule.response.500.title` (string, required)
- `updateCompletionRule.response.500.status` (integer, required)
- `updateCompletionRule.response.500.code` (string, required)
- `updateCompletionRule.response.500.category` (string, required)
  - one of `"validation"`, `"authentication"`, `"authorization"`, `"not_found"`, `"conflict"`, `"precondition"`, `"quota"`, `"rate_limit"`, `"upstream"`, `"internal"`
- `updateCompletionRule.response.500.detail` (string, required)
- `updateCompletionRule.response.500.request_id` (string, required)
- `updateCompletionRule.response.500.docs_url` (string, required)
  - format `uri`
- `updateCompletionRule.response.500.errors` (array<object>, optional)
  - `updateCompletionRule.response.500.errors.path` (string, required) — RFC 6901 JSON Pointer into the request body.
  - `updateCompletionRule.response.500.errors.code` (string, required)
  - `updateCompletionRule.response.500.errors.detail` (string, required)
- `updateCompletionRule.response.500.retry_after` (integer | null, optional)


Source: https://docs.quirelms.com/api/completions/updateCompletionRule/index.md
